//
// lbgvCNX
//
#ifndef	__CNETPLAY_INCLUDED__
#define	__CNETPLAY_INCLUDED__

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <mmsystem.h>
#include <winsock.h>

#include "macro.h"
#include "typedef.h"

#include <string>
using namespace std;

#define	WM_NETPLAY		(WM_APP+100)

#define	WM_NETPLAY_HOSTBYNAME	(WM_APP+101)

#define	WM_NETPLAY_ACCEPT	(WM_APP+110)
#define	WM_NETPLAY_CONNECT	(WM_APP+111)
#define	WM_NETPLAY_CLOSE	(WM_APP+112)
#define	WM_NETPLAY_ERROR	(WM_APP+113)

// for BSD style
#ifndef	INVALID_SOCKET
#define	INVALID_SOCKET	-1
#endif

// for Winsock1.x
#ifndef	SD_RECEIVE
#define	SD_RECEIVE	0
#endif
#ifndef	SD_SEND
#define	SD_SEND		1
#endif
#ifndef	SD_BOTH
#define	SD_BOTH		2
#endif

class	CNetPlay
{
public:
	CNetPlay();
	~CNetPlay();

	// /J
	BOOL	Initialize( HWND hWnd );
	void	Release();

	// lbgvCH
	BOOL	IsNetPlay() { return m_hWnd?TRUE:FALSE; }
	// ڑH
	BOOL	IsConnect() { return m_hWnd?m_bConnect:FALSE; }
	// ڑH
	BOOL	IsServer() { return m_bServer; }

	// ʐMCeV
	void	SetLatency( INT nLatency ) { m_nLatency = nLatency; }
	INT	GetLatency() { return m_nLatency; }

	// 񓯊bZ[WԑEChE̐ݒ
	void	SetMsgWnd( HWND hWnd ) { m_hWndMsg = hWnd; }

	// `bgbZ[W󂯎EChE̐ݒ
	void	SetChatWnd( HWND hWnd ) { m_hWndChat = hWnd; }

	// zXgIPǂ`FbN(0:IP -:Error +:Host search)
	INT	ASyncHostCheck( HWND hWnd, const char* lpszHost );
	HRESULT	ASyncWndProc( HWND hWnd, WPARAM wParam, LPARAM lParam );

	// ڑƐؒf
	BOOL	Connect( BOOL bServer, const char* lpszIP, unsigned short Port );
	void	Disconnect();

	// f[^M 0:Mf[^҂ 1ȏ:Mf[^ 0:ڑ؂G[
	INT	Send( BYTE data );
	// f[^M
	// 0:Mf[^҂ 1ȏ:Mf[^ 0:ڑ؂G[
	// ^CAEg
	INT	Recv( BYTE& data );
	// ^CAEgL
	INT	RecvTime( BYTE& data, unsigned long timeout );

	// Oobt@ւ̎荞
	BOOL	RecvBuffer();
	// obt@`FbN(0:No change  +:frame add  -:no frame)
	INT	BufferCheck();
	// Oobt@̃obt@OoCg擾
	INT	GetRecvBufferSize();

	// 
	INT	Sync();
	// vC[Ԃ̍XV
	INT	ModifyPlayer( LPBYTE p1, LPBYTE p2 );

	// `bgbZ[WM
	void	ChatSend( LPCSTR lpStr );

	// WindowsbZ[WvV[W
	HRESULT	WndProc( HWND hWnd, WPARAM wParam, LPARAM lParam );

	// ʐMobt@
	enum {
		// f[^ubNTCY
		SOCKET_BLOCK_SIZE = 8,
		// obt@TCY
		SOCKET_BUFFER_SIZE = (SOCKET_BLOCK_SIZE*32),
		// Mobt@TCY
		SOCKET_RECEIVE_SIZE = (SOCKET_BLOCK_SIZE*8)
	};
protected:
	// oϐ
	HWND	m_hWnd;
	HWND	m_hWndMsg;
	HWND	m_hWndASync;
	HWND	m_hWndChat;

	HANDLE	m_hASyncTask;
	CHAR	m_HostEntry[MAXGETHOSTSTRUCT];

	BOOL	m_bServer;
	BOOL	m_bConnect;	// ڑH
	INT	m_nLatency;	// CeV(obt@TCY)
	INT	m_nFrameStep;	// ʐMt[[g
	INT	m_nFrameCount;	// JE^

	// Ring buffer
	INT	m_nRingPtr;
	INT	m_nSendPtr;
	INT	m_nRecvPtr;
	INT	m_nRecvSize;
	BYTE	m_SendBuffer[SOCKET_BUFFER_SIZE];
	BYTE	m_RecvBuffer[SOCKET_BUFFER_SIZE];

	// WINSOCK
	WSADATA	m_WSAdata;
	SOCKET	m_SocketConnect;
	SOCKET	m_SocketData;
	SOCKET	m_SocketChat;

	struct sockaddr_in	m_SAddr_Server;
	struct sockaddr_in	m_SAddr_Client;
private:
};

extern	CNetPlay	NetPlay;

#endif	// !__CNETPLAY_INCLUDED__
